package gregapi.block.prefixblock;

import static gregapi.data.CS.NW_API;
import static gregapi.data.CS.W;
import gregapi.network.packets.data.PacketSyncDataShort;
import gregapi.render.IRenderedBlockObject;
import gregapi.render.ITexture;
import gregapi.tileentity.TileEntityBase1;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.Packet;

/**
 * @author Gregorius Techneticies
 */
public class PrefixBlockTileEntity extends TileEntityBase1 implements IRenderedBlockObject {
	public short mMetaData = W;
	public boolean mBlocked = true;
	public NBTTagCompound mItemNBT = null;
	
	public PrefixBlockTileEntity() {super(false);}
	
    @Override
    public void onAdjacentBlockChange(int aX, int aY, int aZ) {
    	if (!worldObj.isRemote && mBlocked) {
    		mBlocked = false;
    		NW_API.sendToAllPlayersInRange(new PacketSyncDataShort(xCoord, yCoord, zCoord, mMetaData), worldObj, xCoord, zCoord);
    	}
    }
    
	@Override
    public Packet getDescriptionPacket() {
		if (!worldObj.isRemote && !(mBlocked = UT.Worlds.isBlockOccluded(worldObj, xCoord, yCoord, zCoord))) {
			NW_API.sendToAllPlayersInRange(new PacketSyncDataShort(xCoord, yCoord, zCoord, mMetaData), worldObj, xCoord, zCoord);
		}
		return null;
    }
	
	private ITexture mTexture;
	
	@Override
	public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide) {
		if (mTexture == null) mTexture = (aBlock instanceof PrefixBlock ? ((PrefixBlock)aBlock).getTexture(mMetaData, worldObj != null) : null);
		return mTexture;
	}
	
	@Override public boolean renderItem(Block aBlock, RenderBlocks aRenderer) {return false;}
	@Override public boolean renderBlock(Block aBlock, RenderBlocks aRenderer) {return false;}
	@Override public boolean setBlockBounds(Block aBlock, int aRenderPass) {return false;}
	@Override public int getRenderPasses(Block aBlock) {return 1;}
	@Override public void readFromNBT(NBTTagCompound aNBT) {super.readFromNBT(aNBT); mMetaData = aNBT.getShort("m"); if (aNBT.hasKey("gt.nbt.drop")) mItemNBT = aNBT.getCompoundTag("gt.nbt.drop");}
    @Override public void writeToNBT(NBTTagCompound aNBT) {super.writeToNBT(aNBT); aNBT.setShort("m", mMetaData); if (mItemNBT != null && !mItemNBT.hasNoTags()) aNBT.setTag("gt.nbt.drop", mItemNBT);}
	@Override public Object getGUIClient(int aGUIID, EntityPlayer aPlayer) {return null;}
	@Override public Object getGUIServer(int aGUIID, EntityPlayer aPlayer) {return null;}
}