package gregapi.render;

import static gregapi.data.CS.*;
import static gregapi.data.CS.SIDE_X_POS;
import static gregapi.data.CS.SIDE_Y_NEG;
import static gregapi.data.CS.SIDE_Y_POS;
import static gregapi.data.CS.SIDE_Z_POS;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.world.IBlockAccess;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.client.registry.ISimpleBlockRenderingHandler;

/**
 * @author Gregorius Techneticies
 */
public class RendererBlockTextured implements ISimpleBlockRenderingHandler {
	public final int mRenderID;
	public static RendererBlockTextured INSTANCE;
	
	public RendererBlockTextured(int aRenderID) {
		INSTANCE = this;
		mRenderID = aRenderID;
	}
	
    @Override
	public void renderInventoryBlock(Block aBlock, int aMetaData, int aModelID, RenderBlocks aRenderer) {
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ITexture.Util.startRendering(aRenderer, aBlock, null, 0, 0, 0);
		
    	if (aBlock instanceof IRenderedBlock) {
        	GL11.glRotatef(90, 0, 1, 0);
        	GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
			boolean tNeedsToSetBounds = true;
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject((short)aMetaData);
    		if (tRenderer == null) {
	        	for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses((short)aMetaData); i < j; i++) {
	        		Tessellator.instance.startDrawingQuads();
	        		if (((IRenderedBlock)aBlock).setBlockBounds(i, (short)aMetaData)) {tNeedsToSetBounds = true; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = false;}
	            	Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_NEG, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_POS, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_NEG, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_POS, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_NEG, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_POS, (short)aMetaData), !tNeedsToSetBounds);
	            	Tessellator.instance.draw();
	        	}
    		} else {
    			if (!tRenderer.renderItem(aBlock, aRenderer)) for (int i = 0, j = tRenderer.getRenderPasses(aBlock); i < j; i++) {
	        		Tessellator.instance.startDrawingQuads();
	        		if (tRenderer.setBlockBounds(aBlock, i)) {tNeedsToSetBounds = true; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = false;}
	            	Tessellator.instance.setNormal( 0, -1,  0); renderNegativeYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Y_NEG), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  1,  0); renderPositiveYFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Y_POS), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  0, -1); renderNegativeZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Z_NEG), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 0,  0,  1); renderPositiveZFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_Z_POS), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal(-1,  0,  0); renderNegativeXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_X_NEG), !tNeedsToSetBounds);
	            	Tessellator.instance.setNormal( 1,  0,  0); renderPositiveXFacing(null, aRenderer, aBlock, 0, 0, 0, tRenderer.getTexture(aBlock, i, SIDE_X_POS), !tNeedsToSetBounds);
	            	Tessellator.instance.draw();
	        	}
    		}
			if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
    	GL11.glTranslatef(0.5F, 0.5F, 0.5F);
    	
		ITexture.Util.endRendering(aRenderer, aBlock, null, 0, 0, 0);
    }
    
    @Override
	public boolean renderWorldBlock(IBlockAccess aWorld, int aX, int aY, int aZ, Block aBlock, int aModelID, RenderBlocks aRenderer) {
        Tessellator.instance.setBrightness(983055);
		boolean rReturn = false;
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ITexture.Util.startRendering(aRenderer, aBlock, aWorld, aX, aY, aZ);
		
    	if (aBlock instanceof IRenderedBlock) {
    		IRenderedBlockObject tRenderer = ((IRenderedBlock)aBlock).passRenderingToObject(aWorld, aX, aY, aZ);
    		if (tRenderer == null) {
    			boolean tNeedsToSetBounds = true;
    			for (int i = 0, j = ((IRenderedBlock)aBlock).getRenderPasses(aWorld, aX, aY, aZ); i < j; i++) {
    				if (((IRenderedBlock)aBlock).setBlockBounds(i, aWorld, aX, aY, aZ)) {tNeedsToSetBounds = true; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = false;}
    				if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
                	if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Y_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
                	if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
                	if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_Z_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
                	if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_NEG, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
                	if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, ((IRenderedBlock)aBlock).getTexture(i, SIDE_X_POS, aWorld, aX, aY, aZ), !tNeedsToSetBounds)) rReturn = true;
    			}
				if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    		} else {
    			if (tRenderer.renderBlock(aBlock, aRenderer)) {
    				rReturn = true;
    			} else {
        			boolean tNeedsToSetBounds = true;
    				for (int i = 0, j = tRenderer.getRenderPasses(aBlock); i < j; i++) {
	    				if (tRenderer.setBlockBounds(aBlock, i)) {tNeedsToSetBounds = true; aRenderer.setRenderBoundsFromBlock(aBlock);} else {if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F); aRenderer.setRenderBoundsFromBlock(aBlock); tNeedsToSetBounds = false;}
	                	if (renderNegativeYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Y_NEG), !tNeedsToSetBounds)) rReturn = true;
	                	if (renderPositiveYFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Y_POS), !tNeedsToSetBounds)) rReturn = true;
	                	if (renderNegativeZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Z_NEG), !tNeedsToSetBounds)) rReturn = true;
	                	if (renderPositiveZFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_Z_POS), !tNeedsToSetBounds)) rReturn = true;
	                	if (renderNegativeXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_X_NEG), !tNeedsToSetBounds)) rReturn = true;
	                	if (renderPositiveXFacing(aWorld, aRenderer, aBlock, aX, aY, aZ, tRenderer.getTexture(aBlock, i, SIDE_X_POS), !tNeedsToSetBounds)) rReturn = true;
    				}
    				if (tNeedsToSetBounds) aBlock.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
    			}
    		}
    	}
		aRenderer.setRenderBoundsFromBlock(aBlock);
		
		ITexture.Util.endRendering(aRenderer, aBlock, aWorld, aX, aY, aZ);
		
    	return rReturn;
    }
    
    public static boolean renderNegativeYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY-1, aZ, 0)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY-1:aY, aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null && aIcon.isValidTexture()) aIcon.renderYNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.5F;
		return true;
    }
    
    public static boolean renderPositiveYFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY+1, aZ, 1)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aFullBlock?aY+1:aY, aZ);
	        aRenderer.enableAO = true;
    	}
		if (aIcon != null && aIcon.isValidTexture()) aIcon.renderYPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 1.0F;
		return true;
	}
    
    public static boolean renderNegativeZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ-1, 2)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ-1:aZ);
	        aRenderer.enableAO = true;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	if (aIcon != null && aIcon.isValidTexture()) aIcon.renderZNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
		aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return true;
    }
    
    public static boolean renderPositiveZFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX, aY, aZ+1, 3)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aX, aY, aFullBlock?aZ+1:aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null && aIcon.isValidTexture()) aIcon.renderZPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.8F;
		return true;
    }
    
    public static boolean renderNegativeXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX-1, aY, aZ, 4)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX-1:aX, aY, aZ);
	        aRenderer.enableAO = true;
    	}
    	if (aIcon != null && aIcon.isValidTexture()) aIcon.renderXNeg(aRenderer, aBlock, aX, aY, aZ, aBrightness);
    	aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return true;
    }
    
    public static boolean renderPositiveXFacing(IBlockAccess aWorld, RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, ITexture aIcon, boolean aFullBlock) {
    	int aBrightness = 240;
    	if (aWorld != null) {
    		if (aFullBlock && !aBlock.shouldSideBeRendered(aWorld, aX+1, aY, aZ, 5)) return false;
    		aBrightness = aBlock.getMixedBrightnessForBlock(aWorld, aFullBlock?aX+1:aX, aY, aZ);
	        aRenderer.enableAO = true;
    	}
		aRenderer.flipTexture = !aFullBlock;
    	if (aIcon != null && aIcon.isValidTexture()) aIcon.renderXPos(aRenderer, aBlock, aX, aY, aZ, aBrightness);
		aRenderer.flipTexture = false;
		aRenderer.colorRedTopLeft = aRenderer.colorRedBottomLeft = aRenderer.colorRedBottomRight = aRenderer.colorRedTopRight = aRenderer.colorGreenTopLeft = aRenderer.colorGreenBottomLeft = aRenderer.colorGreenBottomRight = aRenderer.colorGreenTopRight = aRenderer.colorBlueTopLeft = aRenderer.colorBlueBottomLeft = aRenderer.colorBlueBottomRight = aRenderer.colorBlueTopRight = 0.6F;
		return true;
    }
    
    @Override
	public boolean shouldRender3DInInventory(int aModel) {
        return true;
    }
    
    @Override
	public int getRenderId() {
        return mRenderID;
    }
}